/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once


#pragma pack (push, 1)

class ENetBiosNameService
{
public:
	ENetBiosNameService (void);
	~ENetBiosNameService (void);

	PCHAR	DecodeString	(LPCSTR pszInput, size_t InputLen, LPSTR pszOutput, size_t OutputLen);
	PCHAR	EncodeString	(LPCSTR pszInput, size_t InputLen, LPSTR pszOutput, size_t OutputLen);

	PCHAR	GetName			(LPSTR pszName, size_t Length);
	VOID	SetName			(LPCSTR pszName);
	
	BOOL	IsQuestion		(USHORT Type);
	BOOL	IsAnswer		(USHORT Type);


public:
	EEthernet	m_Ethernet;
	EIpHeader	m_IpHeader;
	EUdpHeader	m_UdpHeader;

public:
		
	USHORT		m_ID;
	USHORT		m_Opecode;
	USHORT		m_Q;
	USHORT		m_A;
	USHORT		m_Keni;
	USHORT		m_Add;
	UCHAR		m_NameLength;
	CHAR		m_Name[32];
	UCHAR		m_NameEnd;
	USHORT		m_Type;
	USHORT		m_Class;

	ULONG		m_Ttl;
	USHORT		m_Length;
	USHORT		m_Flags;
	ULONG		m_SrcAddress;


	//UCHAR		m_Reserved[1500];

};
#pragma pack(pop)
