/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "EOptionListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


BOOL EOptionListCtrl::OnBeginLabelEdit (NMLVDISPINFO* pInfo, TCHAR Char, RECT* pRect)
{
	if (pInfo->item.iSubItem != 1)
	{	return TRUE;
	}

	switch (pInfo->item.iItem)
	{
	case INDEX_SAVE_FOLDER:
		{
			TCHAR szText[1024] = {0};

			StringCchCopy (szText, _countof (szText), pInfo->item.pszText);

			if (EUtility::SelectDirectory (m_hWnd, NULL, szText, szText, _countof (szText)))
			{
				StringCchCat (szText, _countof (szText), _T("\\"));
				//SetItemText (pInfo->item.iItem, pInfo->item.iSubItem, szText);
				HWND			hParent		= ::GetParent (m_hWnd);
				NMLVDISPINFO	Info		= {0};

				Info.hdr.code		= LVN_ENDLABELEDIT;
				Info.hdr.hwndFrom	= m_hWnd;
				Info.hdr.idFrom		= ::GetDlgCtrlID (m_hWnd);;
				Info.item.iItem		= pInfo->item.iItem;
				Info.item.iSubItem	= pInfo->item.iSubItem;
				Info.item.mask		= LVIF_TEXT;
				Info.item.pszText	= szText;

				::SendMessage (::GetParent (m_hWnd), WM_NOTIFY, Info.hdr.idFrom, (LPARAM)&Info);
			}

		}
		break;

	case INDEX_ADD_TIME_DATE:
	case INDEX_MAKE_INFO_TXT:
		{
			EStringArray Array;
			Array.Add (_T("No"));
			Array.Add (_T("Yes"));
			new EComboBox (m_hWnd, pInfo->item.iItem, pInfo->item.iSubItem, &Array, pInfo->item.pszText, pRect);
		}
		break;
	
	case INDEX_NETWORK_NAME:
		{
			new EEdit (m_hWnd, pInfo->item.iItem, pInfo->item.iSubItem, pInfo->item.pszText, Char, pRect);
		}
		break;

	}

	return TRUE;
}

BOOL EOptionListCtrl::OnEndLabelEdit (NMLVDISPINFO* pInfo)
{
	return EEditListCtrl::OnEndLabelEdit (pInfo);
}
