/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once


class EEditListCtrl : public EListCtrl
{
public:
	class EEdit : public EWindow
	{
	public:
		EEdit (HWND hParent, INT Index, INT Column, LPCTSTR pString, TCHAR Char, RECT* pRect);
		virtual BOOL	OnWndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult);

	private:
		INT		m_Index;
		INT		m_Column;
	};

public:
	class EComboBox : public EWindow
	{
	public:
		EComboBox (HWND hParent, INT Index, INT Column, EStringArray* pArray, LPCTSTR pString, RECT* pRect);
		virtual BOOL	OnWndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult);

	private:
		INT		m_Index;
		INT		m_Column;
	};

public:
	EEditListCtrl(void);
	virtual ~EEditListCtrl(void);

	virtual BOOL	OnWndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual	BOOL	OnNotifyRefrection (WPARAM wParam, LPARAM lParam, LRESULT* pResult);

protected:
	BOOL	BeginLabelEdit (NMLVDISPINFO* pInfo, TCHAR Char);
static	BOOL	EndLabelEdit (HWND hWnd, INT Item, INT Column, LPCTSTR pszText);

	virtual BOOL	OnBeginLabelEdit (NMLVDISPINFO* pInfo, TCHAR Char, RECT* pRect);
	virtual BOOL	OnEndLabelEdit (NMLVDISPINFO* pInfo);


};
