/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once

#include "EOptionListCtrl.h"

class ELandeRd : public EWinMain
{
public:
	ELandeRd(void);
	virtual ~ELandeRd(void);

	virtual BOOL	OnInitiInstance ();
	virtual VOID	OnExitInstance ();
	virtual	BOOL	OnPreRegisterClass (WNDCLASSEX* pWndClass);
	virtual BOOL	OnCommand (WPARAM wParam, LPARAM lParam);
	virtual	BOOL	OnNotify (WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual	BOOL	OnCreate (CREATESTRUCT* pStruct);
	virtual	VOID	OnSize (UINT nType, int cx, int cy);
	virtual	VOID	OnDestroy ();

	VOID	OnCmdAbout ();

	VOID	InsertColumn	(EListCtrl* pListCtrl, INT Column, UINT nResId, ULONG Width);

	VOID	LoadSetting		();
	VOID	SaveSetting		();


	static VOID CALLBACK  OnFtpCallBack (ULONG Type, PVOID pData, PVOID pContext);

public:
	EOptionListCtrl		m_OptionListCtrl;
	EListCtrl			m_StatusListCtrl;
	ERdWinPcap			m_WinPcap;
	ERdFtpServer		m_FtpServer;


	enum _STATUS_LIST_COLUMN_INDEX
	{
		STATUS_LIST_COLUMN_FILENAME,
		STATUS_LIST_COLUMN_FILE_LENGTH,
		STATUS_LIST_COLUMN_ELAPSED_TIME,
		STATUS_LIST_COLUMN_ELAPSED_PER,
		STATUS_LIST_COLUMN_RECEIVE_RATE,
		STATUS_LIST_COLUMN_REMAIN_TIME,
		STATUS_LIST_COLUMN_STATUS,
	};

	enum _OPTION_COLUMN_INDEX
	{
		OPTION_LIST_COLUMN_NAME,
		OPTION_LIST_COLUMN_VALUE,
	};


};
