/*---------------------------------------------------------------------------*/
//       Author : HDBENCH.NET
//         Mail : eword@hdbench.net
//          Web : http://hdbench.net/
//      License : The modified BSD license
//
//                           Copyright 2008 HDBENCH.NET, All rights reserved.
/*---------------------------------------------------------------------------*/

// stdafx.cpp : source file that includes just the standard includes
// TEST.pch will be the pre-compiled header
// stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// TODO: reference any additional headers you need in STDAFX.H
// and not in this file


LPSTR StringCchStrStrA (__in LPCSTR pszFirst, __in size_t cchFirst, __in LPCSTR pszSrch)
{
	size_t	Length	= 0;
	LPCSTR	psz		= NULL;
	BOOL	fFound	= FALSE;

    if ((cchFirst > STRSAFE_MAX_CCH) || (cchFirst == 0))
    {
        return NULL;
    }

	psz = pszSrch;
	while (*psz)
	{
		Length++;
		psz++;
		if (Length > STRSAFE_MAX_CCH)
		{	return NULL;
		}
	}

	if (Length == 0)
	{	return NULL;
	}

	while ((cchFirst >= Length) && (*pszFirst != '\0'))
	{
		if (CompareStringA (LOCALE_USER_DEFAULT, 0, pszFirst, (INT)Length, pszSrch, (INT)Length) == CSTR_EQUAL)
		{
			return (LPSTR)pszFirst;
		}

		pszFirst++;
		cchFirst--;
	}

	return NULL;
}

LPWSTR StringCchStrStrW (__in LPCWSTR pszFirst, __in size_t cchFirst, __in LPCWSTR pszSrch)
{
	size_t	Length	= 0;
	LPCWSTR	psz		= NULL;
	BOOL	fFound	= FALSE;

    if ((cchFirst > STRSAFE_MAX_CCH) || (cchFirst == 0))
    {
        return NULL;
    }

	psz = pszSrch;
	while (*psz)
	{
		Length++;
		psz++;
		if (Length > STRSAFE_MAX_CCH)
		{	return NULL;
		}
	}

	if (Length == 0)
	{	return NULL;
	}

	while ((cchFirst >= Length) && (*pszFirst != '\0'))
	{
		if (CompareStringW (LOCALE_USER_DEFAULT, 0, pszFirst, (INT)Length, pszSrch, (INT)Length) == CSTR_EQUAL)
		{
			return (LPWSTR)pszFirst;
		}

		pszFirst++;
		cchFirst--;
	}

	return NULL;
}